/*

*/

import java.math.BigInteger;

/**

*/
public class TestPrime
{
   public static void main(String[] args)
   {
      // Notice how the computational time varies from one
      // number to the next. These are not "equal" work loads.
      long start = 50_000_000_000_000_001L;
      long count = 1_000;
      for (long i = start; i < start+count; i += 2)
      {
         final long startTime = System.currentTimeMillis();
         System.out.print( i + ": " + Primes.isPrime(i) );
         final long stopTime = System.currentTimeMillis();
         System.out.println(" (" + (stopTime - startTime) + "ms)");
      }

      System.out.println();

      // Do the numbers again.
      // This time print out their prme factorizations.
      for (long i = start; i < start+count; i += 2)
      {
         final long startTime = System.currentTimeMillis();
         if ( Primes.isPrime(i) )
         {
            System.out.print(i);
         }
         else
         {
            System.out.print(i + " = " + Primes.factorize(i));
         }
         final long stopTime = System.currentTimeMillis();
         System.out.println(" (" + (stopTime - startTime) + "ms)");
      }


      System.out.println();


      BigInteger startBI = new BigInteger("100000000000000001");
      BigInteger countBI = BigInteger.valueOf(100);
      for (BigInteger i = startBI; i.compareTo(startBI.add(countBI)) < 0; i = i.add(BigInteger.valueOf(2)))
      {
         final long startTime = System.currentTimeMillis();
         if ( Primes.isPrime(i) )
         {
            System.out.print(i);
         }
         else
         {
            System.out.print(i + " = " + Primes.factorize(i));
         }
         final long stopTime = System.currentTimeMillis();
         System.out.println(" (" + (stopTime - startTime) + "ms)");
      }


      System.out.println();
      BigInteger i = new BigInteger("265252859812191058636308479999999");
      System.out.println(i + ": " + Primes.isPrime(i));


      System.out.println();


      javax.swing.SwingUtilities.invokeLater(()->System.out.println(Primes.factorize(new BigInteger("123456789123127"))));
      System.out.println("hello");
      javax.swing.SwingUtilities.invokeLater(()->System.out.println(Primes.factorize(new BigInteger("987654321123125"))));
      System.out.println("hello");
      javax.swing.SwingUtilities.invokeLater(()->System.out.println(Primes.factorize(new BigInteger("898989899123129979959497"))));
      System.out.println("hello");
      javax.swing.SwingUtilities.invokeLater(()->System.out.println(Primes.factorize(new BigInteger("999999999123127"))));
      System.out.println("hello");
   }
}
