/*

*/
import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.TimeUnit;
/**
   Execute 1,000 tasks by placing the tasks in a "task pool" that
   is worked on by a fixed number of threads from a "thread pool".
*/
public class ThreadPoolExample
{
   public static void main(String[] args)
   {
      final long startTime = System.currentTimeMillis();

      for (long i = 0; i < 1_000; ++i) // try 10_000
      {
         final long x = i + 50_000_000_000_000_001L;
         executor.execute( ()->System.out.println(Primes.factorize(x)) );
      }
      executor.shutdown(); // this doesn't wait for the tasks to complete

      try{executor.awaitTermination(1, TimeUnit.MINUTES);}catch(InterruptedException e){}
      final long stopTime = System.currentTimeMillis();
      System.out.println("(" + (stopTime - startTime) + "ms)");
   }

   private static final int cores = Runtime.getRuntime().availableProcessors();
   private static final ExecutorService executor = Executors.newFixedThreadPool(cores);
}
