/*

*/
import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.TimeUnit;
/**
   Execute 1,000 tasks by placing the tasks in a "task pool" that
   is worked on by a fixed number of threads from a "thread pool".
*/
public class ThreadPoolSyntheticWork
{
   public static void main(String[] args) throws InterruptedException
   {
      final long startTime = System.currentTimeMillis();

      for (long i = 0; i < cores * 5; ++i)
      {
         executor.execute( ()->System.out.println(UnitOfWork.fakeWork(5, TimeUnit.SECONDS)) );
       //executor.execute( ()->System.out.println(UnitOfWork.doWork(5, TimeUnit.SECONDS)) );
      }
      executor.shutdown(); // this doesn't wait for the tasks to complete

      executor.awaitTermination(2, TimeUnit.MINUTES); // throws InterruptedException
      final long stopTime = System.currentTimeMillis();
      System.out.println("(" + (stopTime - startTime) + "ms)");
   }

   private static final int cores = Runtime.getRuntime().availableProcessors();
   private static final ExecutorService executor = Executors.newFixedThreadPool(cores);
}
