/*

*/

import java.util.concurrent.CountDownLatch;

/**
   Execute 1,000 tasks with one thread per task
   (so there are 1,000 threads).
*/
public class ThreadedExample
{
   public static void main(String[] args) throws InterruptedException
   {
      final CountDownLatch latch = new CountDownLatch(1_000);
      final long startTime = System.currentTimeMillis();

      for (long i = 0; i < 1_000; ++i) // try 10_000
      {
         final long x = i + 50_000_000_000_000_001L;
         new Thread(()->{System.out.println(Primes.factorize(x));latch.countDown();}).start();
      }

      latch.await(); // throws InterruptedException
      final long stopTime = System.currentTimeMillis();
      System.out.println("(" + (stopTime - startTime) + "ms)");
   }
}
