/*

*/

/**
   Execute 1,000 tasks by placing the tasks in a "task pool" that
   is worked on by a fixed number of threads from a "thread pool".
*/
public class MyThreadPoolExample
{
   private static final int cores = Runtime.getRuntime().availableProcessors();
   private static final MyThreadPool executor = new MyThreadPool(cores);

   public static void main(String[] args)
   {
      final long startTime = System.currentTimeMillis();

      for (long i = 0; i < 1_000; ++i) // try 10_000
      {
         final long x = i + 50_000_000_000_000_001L;
         executor.execute( ()->System.out.println(x + " = " + Prime.factorize(x)) );
      }
      executor.shutdown();

      final long stopTime = System.currentTimeMillis();
      System.out.println("(" + (stopTime - startTime) + "ms using " + cores + " cores)");
   }
}
