/*

*/

/**
   Execute 1,000 tasks by placing the tasks in a "task pool" that
   is worked on by a fixed number of threads from a "thread pool".
*/
public class MyThreadPoolExample_v2
{
   public static void main(String[] args)
   {
      final long startTime = System.currentTimeMillis();

      for (long i = 0; i < 1_000; ++i) // try 10_000
      {
         final long x = i + 50_000_000_000_000_001L;
         executor.execute( ()->System.out.println(x + " = " + Prime.factorize(x)) );
      }
      executor.shutdown();

      final long stopTime = System.currentTimeMillis();
      System.out.println("(" + (stopTime - startTime) + "ms using " + cores + " cores)");
   }

   private static final int cores;
   private static final MyThreadPool executor;

   static
   {
      System.out.println("Please set the number of available cores.");
      System.out.print("When the cores have been chosen, tap Enter to procede: ");
      new java.util.Scanner(System.in).nextLine();
      cores = Runtime.getRuntime().availableProcessors();
      executor = new MyThreadPool(cores);
      System.out.println("Thread pool using " + cores + " cores.");
   }
}
