/*

*/

import java.util.List;
import java.util.ArrayList;

/**

*/
public class Prime
{
   /**
      A naive factorization method. Take integer n, return list of factors.
   */
   public static List<Long> factorize(long n)
   {
      List<Long> factors = new ArrayList<>();

      if (n < 2)
         return factors;

      long p = 2;

      while (true)
      {
         if (n == 1)
            return factors;

         long r = n % p;
         if (r == 0)
         {
            factors.add(p);
            n = n / p;
         }
         else if (p * p >= n)
         {
            factors.add(n);
            return factors;
         }
         else if (p > 2)
         {
            p += 2; // advance in steps of 2 over odd numbers
         }
         else
         {
            p = 3; // if p == 2, get to 3
         }
      }
   }
}
